(function ($) {
  Drupal.behaviors.power_reviews = {
    attach: function (context, settings) {
      var config = drupalSettings.powerreview_api_details;
      var content_type_details = drupalSettings.powerreviews_content_details.power_reviews_product_details;
      var render_obj = [];
      $.each(content_type_details, function(key, value){
        var power_reviews_display = {
          api_key: config.power_reviews_api_key,
          merchant_group_id: config.power_reviews_merchant_group_id,
          merchant_id: config.power_reviews_merchant_id,
          locale: config.power_reviews_locale,
          page_id: value.page_id,
          review_wrapper_url: config.power_reviews_write_review_url + '/?pr_page_id=' + value.page_id,
          components: {
            CategorySnippet: config.power_reviews_applied_categorysnippet + '-' + value.page_id
          }
        };
        if($('#' + config.power_reviews_applied_categorysnippet + '-' + value.page_id).length > 0) {
          render_obj.push(power_reviews_display);
        }
      });
      POWERREVIEWS.display.render(render_obj);
      $(window).on('load', function() {
        setTimeout(function() {
          $('.products-block-wrapper .product-block').each(function() {
            var reviewTxt = $.trim($(this).find('.pr-category-snippet__total').text()).toLowerCase();
            if (reviewTxt.indexOf('no reviews') > -1) {
              $(this).find('.pr-category-snippet__total').text('0');
            } else {
              $(this).find('.pr-category-snippet__total').text(reviewTxt.replace(/[^0-9\.]+/g, ''));
            }
          });
        }, 500);
        $('.products-block-wrapper div[id*="pr-categorysnippet"], .products-block-wrapper .brand-name-wrapper').on('click', function() {
          var getUrl = $(this).attr('data-attr');
          window.location.href = getUrl;
        });
      });
    }
  };
}(jQuery));
