(function ($) {
  Drupal.behaviors.power_reviews = {
    attach: function (context, settings) {
      var config = drupalSettings.powerreview_api_details;
      var content_type_details = drupalSettings.powerreviews_content_details;
      var powerreviews_review_details = drupalSettings.powerreviews_review_details;
      if(content_type_details != undefined && content_type_details.power_reviews_applied_reviewsnippet != '') {
        var review_wrapper_url = config.power_reviews_write_review_url+ '/?&pr_page_id=' + content_type_details.powerreviews_page_id;
        if(content_type_details.power_reviews_type_of_implementation == 'content_type') {
          var review_wrapper_url = config.power_reviews_write_review_url + '/?nid=' + content_type_details.nid + '&pr_page_id=' + content_type_details.powerreviews_page_id;
        }
        POWERREVIEWS.display.render([
        {
          api_key: config.power_reviews_api_key,
          merchant_group_id: config.power_reviews_merchant_group_id,
          merchant_id: config.power_reviews_merchant_id,
          locale: config.power_reviews_locale,
          page_id: content_type_details.powerreviews_page_id,
          review_wrapper_url: review_wrapper_url,
          product: content_type_details.power_reviews_product_details,
          components: {
            ReviewSnippet: content_type_details.power_reviews_applied_reviewsnippet,
            ReviewDisplay: content_type_details.power_reviews_applied_reviewdisplay
          },
          on_render: function(config, data) {
            if (window.location.hash) {
              if (window.location.hash.indexOf('#power-reviews') > -1) {
                $('html,body').animate({
                  scrollTop: $('#pr-reviewdisplay').offset().top - 76
                }, 500);
              }
            }
            var getReviews = $.trim($('#pr-reviewsnippet').find('.pr-snippet-review-count').text()).toLowerCase();
            if(getReviews.indexOf('no reviews') > -1) {
              $('#pr-reviewsnippet').find('.pr-snippet-review-count').text('0');
              $('#pr-reviewdisplay').addClass('no-reviews');
            } else {
              $('#pr-reviewsnippet').find('.pr-snippet-review-count').text(getReviews.replace(/[^0-9\.]+/g, ''));
            }
            $('#pr-rd-main-header .pr-rd-search-reviews-input input[type="search"]').attr('placeholder', 'Search');
            $('#pr-review-snapshot .pr-review-snapshot-header .pr-headline').text('Reviews');
          },
        }
        ]);
      }
    }
  };
}(jQuery));
