(function($) {
  Drupal.behaviors.power_reviews = {
    attach: function(context, settings) {
      var getUrlParameter = function(sParam) {
        var sPageURL = window.location.search.substring(1);
        var sURLVariables = sPageURL.split('&');
        var sParameterName;
        var i;

        for (i = 0; i < sURLVariables.length; i++) {
          sParameterName = sURLVariables[i].split('=');
          if (sParameterName[0] === sParam) {
            return sParameterName[1] === undefined ? true : decodeURIComponent(sParameterName[1]);
          }
        }
      };

      var renderWAR = function(nid) {
        $('#' + powerreviews_review_details.power_reviews_write_review).html('');
        POWERREVIEWS.display.render({
          api_key: config.power_reviews_api_key,
          merchant_group_id: config.power_reviews_merchant_group_id,
          merchant_id: config.power_reviews_merchant_id,
          locale: config.power_reviews_locale,
          page_id: powerreviews_review_details.product_details[nid]['page_id'],

          on_render: function(config, data) {
            // Updating the placeholder which is rendered from an external service(Power reviews).
            var placeholderTxt = $('#pr-comments-input').attr('placeholder').replace(/\./g,'?');
            $('#pr-comments-input').attr('placeholder', placeholderTxt);
            $(window).scrollTop(0);
            // Remove class from an element.
            if($('.pr-custom-header .required-field').hasClass('error')) {
              $('.pr-custom-header .required-field').removeClass('error');
            }
            $('#pr-writereview .pr-submit .pr-btn-review').text('submit');
            $('#pr-product-selector .products-list li').each(function() {
              var productName = $.trim($(this).find('.product-title').text()).toLowerCase();
              if (productName.indexOf('day & night value pack') > -1) {
                $(this).addClass('day-night-pack');
              }
            });
          },
          on_submit: function(config, data) {
            function swapContent() {
              if ($(window).width() < 768) {
                $('.thank-you-page #email_collection + .pr-text').insertBefore('.thank-you-page .pr-rating-date');
              } else {
                $('.thank-you-page .pr-text + .pr-text').insertAfter('.thank-you-page #email_collection');
              }
            }
            $(window).scrollTop(0);
            $('#pr-writereview').addClass('thank-you-wrapper');
            $('#pr-writereview .thank-you-page .header h5 a').text('Back to homepage').attr('href', '/');
            $('.thank-you-page .pr-rating-date').insertBefore('.thank-you-page #selectyourage');
            $('.thank-you-page .pr-rating-stars').insertBefore('.thank-you-page h2.headline');
            $('#pr-product-selector, .required-field').hide();
            $('.thank-you-page .header h3.subtitle').text('We will process your review and publish it within 3-7 business days.');
            swapContent();
            $(window).resize(function() {
              swapContent();
            });
          },
          components: {
            Write: powerreviews_review_details.power_reviews_write_review
          }
        });
      }

      // Check for errors
      $('body').on('click', '.pr-btn-review', function() {
        setTimeout(function() {
          if ($('#pr-writereview').find('.pr-has-error').length) {
            $('.pr-custom-header .required-field').addClass('error');
          }
        }, 500);
      });

      var getAttr = $('#pr-product-selector ul.products-list li#' + getUrlParameter('nid')).attr('style');
      var getUrl = $('#pr-product-selector ul.products-list li#' + getUrlParameter('nid')).attr('data-link');
      var getHtml = $('#pr-product-selector ul.products-list li#' + getUrlParameter('nid')).html();
      var productTitle = $.trim($('#pr-product-selector ul.products-list li#' + getUrlParameter('nid')).find('.product-title').text()).toLowerCase();
      if(productTitle.indexOf('day & night value pack') > -1) {
        $('#pr-product-selector .selected-product').addClass('day-night-pack');
      }
      $('#pr-product-selector .buynow-button a').attr('href', getUrl);
      $('#pr-product-selector .selected-product').attr('style', getAttr).html(getHtml);
      $('#pr-product-selector ul.products-list li#' + getUrlParameter('nid')).addClass('hide');

      $('#pr-product-selector .selected-product').on('click', function(e) {
        e.stopPropagation();
        $(this).siblings('.products-list').stop().slideToggle();
      });

      $('#pr-product-selector ul.products-list li').on('click', function(e) {
        var selectedStyle = $(this).attr('style');
        var selectedHtml = $(this).html();
        e.stopPropagation();
        if($(this).hasClass('day-night-pack')) {
          $('#pr-product-selector .selected-product').addClass('day-night-pack');
        } else {
          $('#pr-product-selector .selected-product').removeClass('day-night-pack');
        }
        $('#pr-product-selector .selected-product').attr('style', selectedStyle).html(selectedHtml);
        $('#pr-product-selector ul.products-list').slideToggle();
        $('#pr-product-selector ul.products-list li').removeClass('hide');
        $(this).addClass('hide');
      });

      $(document).click(function() {
        if ($('#pr-product-selector ul.products-list').is(':visible')) {
          $('#pr-product-selector .products-list').hide();
        }
      });

      var config = drupalSettings.powerreview_api_details;
      var powerreviews_review_details = drupalSettings.powerreviews_review_details;
      if (powerreviews_review_details != undefined) {
        if (powerreviews_review_details.power_reviews_write_review_custom_header == 'No') {
          POWERREVIEWS.display.render({
            api_key: config.power_reviews_api_key,
            merchant_group_id: config.power_reviews_merchant_group_id,
            merchant_id: config.power_reviews_merchant_id,
            locale: config.power_reviews_locale,
            page_id: powerreviews_review_details.powerreviews_page_id,
            on_submit: function(config, data) {
              $('.pr-custom-header, .required-field').hide();
            },
            components: {
              Write: powerreviews_review_details.power_reviews_write_review
            }
          });
        } else {
          $(window).on('load', function() {
            renderWAR(getUrlParameter('nid'));
          });
          $('#pr-product-selector li').on('click', function() {
            renderWAR($(this).attr('id').toString());
          });
        }
      }
    }
  };
}(jQuery));
