<?php

namespace Drupal\power_reviews\Routing;

use Symfony\Component\Routing\Route;
use Symfony\Component\Routing\RouteCollection;
use Drupal\Core\Routing\RouteSubscriberBase;

/**
 * Defines dynamic routes.
 */
class PowerReviewsRouteSubscriber extends RouteSubscriberBase {

  /**
   * {@inheritdoc}
   */
  public function routes() {
    $routes = [];

    // Declares a single route under the name 'power_reviews.write_review'.
    // Returns an array of Route objects.
    $routes['power_reviews.write_review'] = new Route(
      // Path to attach this route to:
      \Drupal::config('power_reviews.settings')->get('power_reviews_write_review_link'),
      // Route defaults:
      [
        '_controller' => '\Drupal\power_reviews\Controller\PowerReviewsController::writeReview',
        '_title' => \Drupal::config('power_reviews.settings')->get('power_reviews_write_review_page_title'),
      ],
      // Route requirements:
      [
        '_permission' => 'access content',
      ]
    );

    return $routes;
  }

  /**
   * {@inheritdoc}
   */
  protected function alterRoutes(RouteCollection $collection) {
    // Change path '/user/login' to '/login'.
    if ($route = $collection->get('power_reviews.write_review')) {
      $route->setPath(\Drupal::config('power_reviews.settings')->get('power_reviews_write_review_link'));
    }
    // Always deny access to '/user/logout'.
    // Note that the second parameter of setRequirement() is a string.
    if ($route = $collection->get('user.logout')) {
      $route->setDefault('_title', \Drupal::config('power_reviews.settings')->get('power_reviews_write_review_page_title'));
    }
  }

}
